package me.Demon.DemonLevels.util;

import me.Demon.DemonLevels.manage.MobsManage;
import org.bukkit.configuration.ConfigurationSection;
import org.bukkit.configuration.file.FileConfiguration;

import java.util.HashMap;
import java.util.Map;
import java.util.TreeMap;

public class ConfigYml {

    private TreeMap<Integer,String> rankTitleMap = new TreeMap<>();
    private HashMap<String, MobsManage> manageHashMap = new HashMap<>();

    public ConfigYml(FileConfiguration yml){
        loadRankTitle(yml);
        loadMobExperienceManagement(yml);
    }

    public void loadMobExperienceManagement(FileConfiguration yml){
        ConfigurationSection section = yml.getConfigurationSection("MobKillExp");
        if(section == null){
            System.out.println("[错误报告] MobKillExp 配置不存在.");
            return;
        }
        for (String mmKey : section.getKeys(false)){
            manageHashMap.put(mmKey,new MobsManage(mmKey,yml));
        }
    }

    public MobsManage getMobsManage(String mmKey){
        if(this.manageHashMap.get(mmKey) != null){
            return this.manageHashMap.get(mmKey);
        }
        return null;
    }

    public void loadRankTitle(FileConfiguration yml){
        ConfigurationSection section = yml.getConfigurationSection("CustonName");
        if(section == null){
            System.out.println("[错误报告] CustonName 配置不存在.");
            return;
        }
        for (String levelKey : section.getKeys(false)){
            int level = Integer.parseInt(levelKey);
            String title = section.getString(levelKey);
            if(title != null){
                rankTitleMap.put(level,title);
            }
        }
    }

    private String getRankTitle(int level) {
        Map.Entry<Integer, String> entry = rankTitleMap.floorEntry(level);
        if (entry != null) {
            return entry.getValue();
        }
        return "§7器士";
    }

}
